Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/interp.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/interp.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/interp.f90	(revision 5075)
@@ -972,79 +924,20 @@
 
       !3- interpolate
-      DO jl=1,tl_mix%t_dim(4)%i_len
-         IF( il_rho(jp_K) /= 1 )THEN
-!            CALL interp__3D(tl_mix%d_value(:,:,:,jl), tl_mix%d_fill, &
-!              &             il_detect(:,:,:), cd_method,             &
-!              &             il_rhoi, il_rhoj, il_rhok,               &
-!              &             ll_even(:), ll_discont )
-             CALL logger_error("INTERP FILL: can not interpolate "//&
-             &                "vertically for now ")
-         ENDIF
-
-         IF( ANY(il_detect(:,:,:)==1) )THEN
-            ! I-J plan
-            DO jk=1,tl_mix%t_dim(3)%i_len
-              CALL interp__2D(tl_mix%d_value(:,:,jk,jl), tl_mix%d_fill, &
-              &               il_detect(:,:,jk), cd_method,             &
-              &               il_rho(jp_I), il_rho(jp_J),               &
-              &               ll_even(1:2), ll_discont)
-            ENDDO
-            IF( ALL(il_detect(:,:,:)==0) ) CYCLE
-            IF( il_rho(jp_K) /= 1 )THEN
-               ! I-K plan
-               DO jj=1,tl_mix%t_dim(2)%i_len
-                  CALL interp__2D(tl_mix%d_value(:,jj,:,jl), tl_mix%d_fill, &
-                  &               il_detect(:,jj,:), cd_method,             &
-                  &               il_rho(jp_J), il_rho(jp_K),               &
-                  &               ll_even(1:3:2), ll_discont  )
-               ENDDO
-               IF( ALL(il_detect(:,:,:)==0) ) CYCLE
-               ! J-K plan
-               DO ji=1,tl_mix%t_dim(1)%i_len
-                  CALL interp__2D(tl_mix%d_value(ji,:,:,jl), tl_mix%d_fill, &
-                  &               il_detect(ji,:,:), cd_method,             &
-                  &               il_rho(jp_J), il_rho(jp_K),               &
-                  &               ll_even(2:3), ll_discont )
-               ENDDO
-
-            ENDIF
-            IF( ANY(il_detect(:,:,:)==1) )THEN
-               ! I direction
-               DO jk=1,tl_mix%t_dim(3)%i_len
-                  DO jj=1,tl_mix%t_dim(2)%i_len
-                     CALL interp__1D( tl_mix%d_value(:,jj,jk,jl),    &
-                     &                tl_mix%d_fill,                 &
-                     &                il_detect(:,jj,jk), cd_method, &
-                     &                il_rho(jp_I),                  &
-                     &                ll_even(1), ll_discont )
-                  ENDDO
-               ENDDO
-               IF( ALL(il_detect(:,:,:)==0) ) CYCLE
-               ! J direction
-               DO jk=1,tl_mix%t_dim(3)%i_len
-                  DO ji=1,tl_mix%t_dim(1)%i_len
-                     CALL interp__1D( tl_mix%d_value(ji,:,jk,jl),    &
-                     &                tl_mix%d_fill,                 &
-                     &                il_detect(ji,:,jk), cd_method, &
-                     &                il_rho(jp_J),                  &
-                     &                ll_even(2), ll_discont )
-                  ENDDO
-               ENDDO
-               IF( il_rho(jp_K) /= 1 )THEN
-                  IF( ALL(il_detect(:,:,:)==0) ) CYCLE
-                  ! K direction
-                  DO jj=1,tl_mix%t_dim(2)%i_len
-                     DO ji=1,tl_mix%t_dim(1)%i_len
-                        CALL interp__1D( tl_mix%d_value(ji,jj,:,jl),    &
-                        &                tl_mix%d_fill,                 & 
-                        &                il_detect(ji,jj,:), cd_method, &
-                        &                il_rho(jp_K),                  &
-                        &                ll_even(3), ll_discont  )
-                     ENDDO
-                  ENDDO
-               ENDIF
-            ENDIF
-         ENDIF
-      ENDDO
+      CALL logger_debug("INTERP 2D: interpolation method "//TRIM(cd_method)//&
+      &  " discont "//TRIM(fct_str(ll_discont)) )
+      SELECT CASE(TRIM(cd_method))
+      CASE('cubic')
+         CALL interp_cubic_fill(tl_mix%d_value(:,:,:,:), tl_mix%d_fill, &
+           &                    il_detect(:,:,:),                        &
+           &                    il_rho(:), ll_even(:), ll_discont )
+      CASE('nearest')
+         CALL interp_nearest_fill(tl_mix%d_value(:,:,:,:), &
+              &                   il_detect(:,:,:),         &
+              &                   il_rho(:) )
+      CASE DEFAULT ! linear
+         CALL interp_linear_fill(tl_mix%d_value(:,:,:,:), tl_mix%d_fill, &
+              &                  il_detect(:,:,:),                        &
+              &                  il_rho(:), ll_even(:), ll_discont )
+      END SELECT         
 
       IF( ANY(il_detect(:,:,:)==1) )THEN
